'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _backbone = require('backbone');

var Backbone = _interopRequireWildcard(_backbone);

var _modelMeasure = require('./model-measure.js');

var _modelMeasure2 = _interopRequireDefault(_modelMeasure);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Measures = function (_Backbone$Collection) {
    _inherits(Measures, _Backbone$Collection);

    function Measures() {
        _classCallCheck(this, Measures);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Measures).call(this));

        _this.model = _modelMeasure2.default;
        // Keep sorted by index value
        _this.comparator = "index";
        return _this;
    }

    _createClass(Measures, [{
        key: 'generateOptimizedEMAExpr',
        value: function generateOptimizedEMAExpr() {

            var _makeIndexRange = function _makeIndexRange(s, i, m, c, sep) {
                var m_idx = m.get("index");
                if (i > 0) {
                    var prev_idx = c[i - 1].get("index");
                    if (m_idx == prev_idx + 1) {
                        // IT'S CONTINGUOS: MERGE
                        if (!s.endsWith("-")) {
                            s += "-";
                        }
                        if (c[i + 1]) {
                            var next_idx = c[i + 1].get("index");
                            if (m_idx + 1 != next_idx) {
                                // End of range
                                s += m_idx;
                            }
                        } else {
                            // End of range
                            s += m_idx;
                        }
                    } else {
                        // NOT CONTIGUOS: ADD
                        s += sep + m_idx;
                    }
                } else {
                    // START
                    s += m_idx;
                }

                return s;
            };

            var sMeasures = "";
            var sStaves = "";
            var sBeats = "";

            var measures = this.models;
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = measures.entries()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var _step$value = _slicedToArray(_step.value, 2);

                    var i = _step$value[0];
                    var measure = _step$value[1];


                    sMeasures = _makeIndexRange(sMeasures, i, measure, measures, ",");

                    var staves = measure.get("staves").models;
                    var _iteratorNormalCompletion2 = true;
                    var _didIteratorError2 = false;
                    var _iteratorError2 = undefined;

                    try {
                        for (var _iterator2 = staves.entries()[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                            var _step2$value = _slicedToArray(_step2.value, 2);

                            var _i = _step2$value[0];
                            var staff = _step2$value[1];


                            sStaves = _makeIndexRange(sStaves, _i, staff, staves, "+");

                            var evs = staff.get("events");
                            var beats = staff.get("beats").models;
                            var _iteratorNormalCompletion3 = true;
                            var _didIteratorError3 = false;
                            var _iteratorError3 = undefined;

                            try {
                                for (var _iterator3 = beats.entries()[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                                    var _step3$value = _slicedToArray(_step3.value, 2);

                                    var _i2 = _step3$value[0];
                                    var beat = _step3$value[1];

                                    // Determine if this beat is contiguos to the previous one
                                    var cur_ev = beat.get("event");
                                    var i_ev = evs.indexOf(cur_ev);
                                    if (_i2 > 0) {
                                        var prev_b = beats[_i2 - 1].get("event");
                                        if (i_ev < 0) {
                                            throw "Unexpected: cannot find event in list of events with beat.";
                                        }
                                        if (evs[i_ev - 1] == prev_b) {
                                            // IT'S CONTINGUOS: MERGE
                                            if (!sBeats.endsWith("-")) {
                                                sBeats += "-";
                                            }
                                            if (beats[_i2 + 1]) {
                                                var next_b = beats[_i2 + 1].get("event");
                                                if (evs[i_ev + 1] != next_b) {
                                                    // End of range
                                                    sBeats += beat.get("value");
                                                }
                                            } else {
                                                // End of range
                                                sBeats += beat.get("value");
                                            }
                                        } else {
                                            // NOT CONTIGUOS: ADD
                                            sBeats += "@" + beat.get("value");
                                        }
                                    } else {
                                        // NOT CONTIGUOS: ADD
                                        sBeats += "@" + beat.get("value");
                                    }
                                }
                            } catch (err) {
                                _didIteratorError3 = true;
                                _iteratorError3 = err;
                            } finally {
                                try {
                                    if (!_iteratorNormalCompletion3 && _iterator3.return) {
                                        _iterator3.return();
                                    }
                                } finally {
                                    if (_didIteratorError3) {
                                        throw _iteratorError3;
                                    }
                                }
                            }

                            if (staves[_i + 1]) {
                                sBeats += "+";
                            }
                        }
                    } catch (err) {
                        _didIteratorError2 = true;
                        _iteratorError2 = err;
                    } finally {
                        try {
                            if (!_iteratorNormalCompletion2 && _iterator2.return) {
                                _iterator2.return();
                            }
                        } finally {
                            if (_didIteratorError2) {
                                throw _iteratorError2;
                            }
                        }
                    }

                    if (measures[i + 1]) {
                        sStaves += ",";
                        sBeats += ",";
                    }
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            if (sMeasures && sStaves && sBeats) {
                return sMeasures + '/' + sStaves + '/' + sBeats;
            } else {
                return "";
            }
        }
    }, {
        key: 'generateEMAExpr',
        value: function generateEMAExpr() {}
    }]);

    return Measures;
}(Backbone.Collection);

exports.default = Measures;